commit 8ef35a37143669ee148cc655f3cc52bab0ec7158
Author: freddy77 <freddy77>
Date:   Fri Aug 21 10:11:19 2009 +0000

    fix variant type for data converted to client encoding

diff --git a/ChangeLog b/ChangeLog
index 008665a..d029572 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Fri Aug 21 12:10:57 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/tds/data.c src/tds/token.c:
+	- fix variant type for data converted to client encoding
+
 Fri Aug 21 12:01:24 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/net.c:
 	- make ssl more threadsafe using pthread in libgcrypt if possible
@@ -1782,4 +1786,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2856 2009/08/21 10:01:52 freddy77 Exp $
+$Id: ChangeLog,v 1.2857 2009/08/21 10:11:19 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index a85315c..744ae2e 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.319 2009/08/20 17:53:06 freddy77 Exp $ */
+/* $Id: tds.h,v 1.320 2009/08/21 10:11:19 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -1430,6 +1430,7 @@ unsigned char *tds7_crypt_pass(const unsigned char *clear_pass, size_t len, unsi
 TDSDYNAMIC *tds_lookup_dynamic(TDSSOCKET * tds, const char *id);
 /*@observer@*/ const char *tds_prtype(int token);
 int tds_get_varint_size(TDSSOCKET * tds, int datatype);
+int tds_get_cardinal_type(int datatype);
 
 
 
diff --git a/src/tds/data.c b/src/tds/data.c
index f9d08c9..c8a4767 100644
--- a/src/tds/data.c
+++ b/src/tds/data.c
@@ -35,11 +35,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: data.c,v 1.22 2009/08/20 17:49:07 freddy77 Exp $");
-
-#if !ENABLE_EXTRA_CHECKS
-static int tds_get_cardinal_type(int datatype);
-#endif
+TDS_RCSID(var, "$Id: data.c,v 1.23 2009/08/21 10:11:20 freddy77 Exp $");
 
 /**
  * Set type of column initializing all dependency 
@@ -137,9 +133,6 @@ tds_set_param_type(TDSSOCKET * tds, TDSCOLUMN * curcol, TDS_SERVER_TYPE type)
 	}
 }
 
-#if !ENABLE_EXTRA_CHECKS
-static
-#endif
 int
 tds_get_cardinal_type(int datatype)
 {
diff --git a/src/tds/token.c b/src/tds/token.c
index 680b740..22cfb0a 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.371 2009/08/20 18:59:29 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.372 2009/08/21 10:11:20 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -2062,6 +2062,7 @@ tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
 				return TDS_FAIL;
 			if (tds_get_char_data(tds, (char *) v->data, colsize, curcol) == TDS_FAIL)
 				return TDS_FAIL;
+			v->type = tds_get_cardinal_type(type);
 		} else {
 			v->data = (TDS_CHAR*) malloc(colsize);
 			if (!v->data)

